#ifndef _MAsignatura_h_
#define _MAsignatura_h_
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
#include "MError.h"

using namespace std;
using namespace MError;

namespace MAsignatura
{
   const unsigned int MAX_ALUM = 65;
   const char ENTER = '\n';
   const char SP = ' ';
   
   typedef unsigned int TNatural;
   struct TAsignatura
   {
     TNatural codigo;
     string titulacion;
     TNatural curso;
     TNatural matriculados;
   };
   
   TNatural Codigo(TAsignatura a); 
   // Devuleve el cdigo de la asignatura que se le pasa como parmetro
   TNatural Curso(TAsignatura a); 
   // Devuleve el curso de la asignatura que se le pasa como parmetro
   string Titulacion(TAsignatura a); 
   // Devuleve la titulacin de la asignatura que se le pasa como parmetro
   TNatural Matriculados(TAsignatura a); 
   // Devuleve el nmero de alumnos matriculados de la asignatura que se le pasa como parmetro
   void Matricula(TAsignatura &a, TNatural num, TError &error ); 
   // Devuleve el nmero de alumnos matriculados de la asignatura que se le pasa como parmetro
   void LeeAsignatura(TAsignatura &a);
   // Lee una asignatura desde teclado
   void EscribeAsignatura(TAsignatura a);
   // Escribe una asignatura por pantalla
   void LeeAsignaturaFichero(ifstream &fich, TAsignatura &a);
   // Lee una asignatura desde un fichero de texto cuyo manejador se le pasa como parmetro
   void EscribeAsignaturaFichero(ofstream &fich, TAsignatura a);
   // Escribe una asignatura en un fichero de texto cuyo manejador se le pasa como parmetro
}
#endif
