/*----------------------------------------------------------------
|	Autor:                                                        |
|	Fecha:                            Versin: 1.0	              |
|-----------------------------------------------------------------|
|	Descripcin del Programa:                                     |
|  								                                  |
| ----------------------------------------------------------------*/

// Incluir E/S y Libreras Standard
#include <iostream>
#include <cstdlib>
#include <string>
#include "MError.h"
#include "MAsignatura.h"
#include "MLista.h"
#include "MUMA.h"

using namespace std;
using namespace MError;
using namespace MAsignatura;
using namespace MLista;
using namespace MUMA;

// Zona de Declaracin de Constantes


// Zona de Declaracin de Tipos

// Zona de Cabeceras de Procedimientos y Funciones
char menu();
bool Confirmar();
void LeerCentro( TCentro &c);

// Programa Principal
int main()
{
  // Zona de Declaracin de Variables del Programa principal
  char op;
  bool salir;
  TUMA tabla;
  TError error;
  TCentro c;
  TAsignatura a;
  string nomFich;
  TNatural codigo;
  
  salir = false;
  CrearUMA(tabla);
  
  while(!salir)
  {
    error = NoError;           
    op = menu();
    cout << endl;
    
    switch(op)
    {
       case 'A': LeerCentro(c);
                 LeeAsignatura(a);
                 InsertarAsignaturaUMA(tabla, c, a, error);
                 break;
       case 'B': cout << "Listado de Asignaturas por Centro" << endl;
                 cout << "=================================" << endl;
                 ListarAsignaturasUMA(tabla);
                 break;
       case 'C': cout << "Nombre del Fichero: ";
                 getline(cin,nomFich,ENTER);
                 CargarAsignaturasUMAFichero(tabla,nomFich,error);
                 break;
       case 'D': cout << "Nombre del Fichero: ";
                 getline(cin,nomFich,ENTER);
                 SalvarAsignaturasUMAFichero(tabla,nomFich,error);
                 break;
       case 'E': cout << "Codigo de la Asignatura: ";
                 cin >> codigo;
                 cin.ignore();
                 BuscarAsignaturaUMA(tabla, codigo, c, a, error);
                 if (error==NoError)
                 {
                    cout << "Centro: " << Centro_a_Cadena(c) << endl;
                    EscribeAsignatura(a);
                    cout << endl;                                     
                 }
                 break;
       case 'F': cout << "Codigo de la Asignatura: ";
                 cin >> codigo;
                 cin.ignore();
                 MatricularAsignaturaUMA(tabla, codigo, error);
                 break;
       case 'G': cout << "Nombre del Fichero: ";
                 getline(cin,nomFich,ENTER);
                 GestionAutomaticaMatriculacion(tabla,nomFich);
                 break;
       case 'X': salir = Confirmar();
                 cout << endl << endl;
                 break;    
       default: cout << "Opcin Incorrecta" << endl;
    }
    MostrarError(error);
    system("Pause"); // Hacer una pausa
    system("cls");   // Borrar Pantalla
  }
  DestruirUMA(tabla);
  return 0;	   // Valor de retorno al S.O.
}

// Implementacin de Procedimientos y Funciones
char menu()
{
  char op;
  
  cout << "Nombre: (Apellidos, Nombre)    Curso: 1" << endl;
  cout << "Especialidad: Sistemas         Grupo: A/B/C" << endl;
  cout << "Puesto: nmero de ordenador    Fecha: 10/09/2010" << endl;
  cout << endl;
  cout << "          ASIGNATURAS UMA" << endl;
  cout << "          ===============" << endl;
  cout << "  A. Insertar Asignatura." << endl;
  cout << "  B. Listar Asignaturas." << endl;
  cout << "  C. Cargar Asignaturas desde Fichero." << endl;
  cout << "  D. Salvar Asignaturas a Fichero." << endl;
  cout << "  E. Buscar Asignatura." << endl;
  cout << "  F. Matricular alumno." << endl;
  cout << "  G. Gestin automtica de matriculacin." << endl;
  cout << "  X. Salir del Programa" << endl;
  cout << endl;
  cout << "  Introduzca su opcion: " ;
  
  cin >> op;
  cin.ignore();
  op = toupper(op);
  
  return op;

}

bool Confirmar()
{ 
  char car;

  cout << "?Esta seguro(S/N)?";
  cin >> car;
  cin.ignore();
  car = toupper(car);
  
  return (car=='S');
}

void LeerCentro( TCentro &c)
{
     string s;
     bool ok;
     
     do
     {
          cout << "Centro: ";
          getline(cin,s,ENTER);
          Cadena_a_Centro(s, c, ok);
     } while (!ok);
}
